/*
 * Copyright (c) 2022 Contributors to the Eclipse Foundation.
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *   Data In Motion - initial API and implementation 
 */
package org.eclipse.sensinact.model.core.provider;

import org.eclipse.sensinact.gateway.geojson.GeoJsonObject;

import org.osgi.annotation.versioning.ProviderType;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Admin</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link org.eclipse.sensinact.model.core.provider.Admin#getFriendlyName <em>Friendly Name</em>}</li>
 *   <li>{@link org.eclipse.sensinact.model.core.provider.Admin#getLocation <em>Location</em>}</li>
 *   <li>{@link org.eclipse.sensinact.model.core.provider.Admin#getModelPackageUri <em>Model Package Uri</em>}</li>
 *   <li>{@link org.eclipse.sensinact.model.core.provider.Admin#getModel <em>Model</em>}</li>
 * </ul>
 *
 * @see org.eclipse.sensinact.model.core.provider.ProviderPackage#getAdmin()
 * @model
 * @generated
 */
@ProviderType
public interface Admin extends Service {
	/**
	 * Returns the value of the '<em><b>Friendly Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Friendly Name</em>' attribute.
	 * @see #isSetFriendlyName()
	 * @see #unsetFriendlyName()
	 * @see #setFriendlyName(String)
	 * @see org.eclipse.sensinact.model.core.provider.ProviderPackage#getAdmin_FriendlyName()
	 * @model unsettable="true" required="true"
	 * @generated
	 */
	String getFriendlyName();

	/**
	 * Sets the value of the '{@link org.eclipse.sensinact.model.core.provider.Admin#getFriendlyName <em>Friendly Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Friendly Name</em>' attribute.
	 * @see #isSetFriendlyName()
	 * @see #unsetFriendlyName()
	 * @see #getFriendlyName()
	 * @generated
	 */
	void setFriendlyName(String value);

	/**
	 * Unsets the value of the '{@link org.eclipse.sensinact.model.core.provider.Admin#getFriendlyName <em>Friendly Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetFriendlyName()
	 * @see #getFriendlyName()
	 * @see #setFriendlyName(String)
	 * @generated
	 */
	void unsetFriendlyName();

	/**
	 * Returns whether the value of the '{@link org.eclipse.sensinact.model.core.provider.Admin#getFriendlyName <em>Friendly Name</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Friendly Name</em>' attribute is set.
	 * @see #unsetFriendlyName()
	 * @see #getFriendlyName()
	 * @see #setFriendlyName(String)
	 * @generated
	 */
	boolean isSetFriendlyName();

	/**
	 * Returns the value of the '<em><b>Location</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Location</em>' attribute.
	 * @see #isSetLocation()
	 * @see #unsetLocation()
	 * @see #setLocation(GeoJsonObject)
	 * @see org.eclipse.sensinact.model.core.provider.ProviderPackage#getAdmin_Location()
	 * @model unsettable="true" dataType="org.eclipse.sensinact.model.core.provider.EGeoJsonObject"
	 * @generated
	 */
	GeoJsonObject getLocation();

	/**
	 * Sets the value of the '{@link org.eclipse.sensinact.model.core.provider.Admin#getLocation <em>Location</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Location</em>' attribute.
	 * @see #isSetLocation()
	 * @see #unsetLocation()
	 * @see #getLocation()
	 * @generated
	 */
	void setLocation(GeoJsonObject value);

	/**
	 * Unsets the value of the '{@link org.eclipse.sensinact.model.core.provider.Admin#getLocation <em>Location</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetLocation()
	 * @see #getLocation()
	 * @see #setLocation(GeoJsonObject)
	 * @generated
	 */
	void unsetLocation();

	/**
	 * Returns whether the value of the '{@link org.eclipse.sensinact.model.core.provider.Admin#getLocation <em>Location</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Location</em>' attribute is set.
	 * @see #unsetLocation()
	 * @see #getLocation()
	 * @see #setLocation(GeoJsonObject)
	 * @generated
	 */
	boolean isSetLocation();

	/**
	 * Returns the value of the '<em><b>Model Package Uri</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Model Package Uri</em>' attribute.
	 * @see #isSetModelPackageUri()
	 * @see #unsetModelPackageUri()
	 * @see #setModelPackageUri(String)
	 * @see org.eclipse.sensinact.model.core.provider.ProviderPackage#getAdmin_ModelPackageUri()
	 * @model unsettable="true" required="true"
	 * @generated
	 */
	String getModelPackageUri();

	/**
	 * Sets the value of the '{@link org.eclipse.sensinact.model.core.provider.Admin#getModelPackageUri <em>Model Package Uri</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Model Package Uri</em>' attribute.
	 * @see #isSetModelPackageUri()
	 * @see #unsetModelPackageUri()
	 * @see #getModelPackageUri()
	 * @generated
	 */
	void setModelPackageUri(String value);

	/**
	 * Unsets the value of the '{@link org.eclipse.sensinact.model.core.provider.Admin#getModelPackageUri <em>Model Package Uri</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetModelPackageUri()
	 * @see #getModelPackageUri()
	 * @see #setModelPackageUri(String)
	 * @generated
	 */
	void unsetModelPackageUri();

	/**
	 * Returns whether the value of the '{@link org.eclipse.sensinact.model.core.provider.Admin#getModelPackageUri <em>Model Package Uri</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Model Package Uri</em>' attribute is set.
	 * @see #unsetModelPackageUri()
	 * @see #getModelPackageUri()
	 * @see #setModelPackageUri(String)
	 * @generated
	 */
	boolean isSetModelPackageUri();

	/**
	 * Returns the value of the '<em><b>Model</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Model</em>' attribute.
	 * @see #isSetModel()
	 * @see #unsetModel()
	 * @see #setModel(String)
	 * @see org.eclipse.sensinact.model.core.provider.ProviderPackage#getAdmin_Model()
	 * @model unsettable="true" required="true"
	 * @generated
	 */
	String getModel();

	/**
	 * Sets the value of the '{@link org.eclipse.sensinact.model.core.provider.Admin#getModel <em>Model</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Model</em>' attribute.
	 * @see #isSetModel()
	 * @see #unsetModel()
	 * @see #getModel()
	 * @generated
	 */
	void setModel(String value);

	/**
	 * Unsets the value of the '{@link org.eclipse.sensinact.model.core.provider.Admin#getModel <em>Model</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetModel()
	 * @see #getModel()
	 * @see #setModel(String)
	 * @generated
	 */
	void unsetModel();

	/**
	 * Returns whether the value of the '{@link org.eclipse.sensinact.model.core.provider.Admin#getModel <em>Model</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Model</em>' attribute is set.
	 * @see #unsetModel()
	 * @see #getModel()
	 * @see #setModel(String)
	 * @generated
	 */
	boolean isSetModel();

} // Admin
