/*
 * Copyright (c) 2022 Contributors to the Eclipse Foundation.
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *   Data In Motion - initial API and implementation 
 */
package org.eclipse.sensinact.model.core.provider;

import org.eclipse.emf.common.util.EMap;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.ETypedElement;

import org.osgi.annotation.versioning.ProviderType;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Service</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link org.eclipse.sensinact.model.core.provider.Service#getMetadata <em>Metadata</em>}</li>
 * </ul>
 *
 * @see org.eclipse.sensinact.model.core.provider.ProviderPackage#getService()
 * @model
 * @generated
 */
@ProviderType
public interface Service extends EObject {
	/**
	 * Returns the value of the '<em><b>Metadata</b></em>' map.
	 * The key is of type {@link org.eclipse.emf.ecore.ETypedElement},
	 * and the value is of type {@link org.eclipse.sensinact.model.core.provider.Metadata},
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Metadata</em>' map.
	 * @see org.eclipse.sensinact.model.core.provider.ProviderPackage#getService_Metadata()
	 * @model mapType="org.eclipse.sensinact.model.core.provider.FeatureMetadata&lt;org.eclipse.emf.ecore.ETypedElement, org.eclipse.sensinact.model.core.provider.Metadata&gt;"
	 * @generated
	 */
	EMap<ETypedElement, Metadata> getMetadata();

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * The eIsSet works a bit differently than the EMF Default. An EAttribute is seen as set, if it is the default value or if the Metadata with a timestamp are available.
	 * <!-- end-model-doc -->
	 * @model
	 * @generated
	 */
	boolean eIsSet(EStructuralFeature feature);

} // Service
